package de.w665.sharepulse.service;

import de.w665.sharepulse.exception.NoDownloadPermissionException;
import de.w665.sharepulse.model.FileUpload;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.io.File;

@Slf4j
@Service
public class FileSecurityService {

    public boolean verifyDownloadPermission(FileUpload file, String password) throws NoDownloadPermissionException {


        if (!file.isPasswordProtected() && !file.isSingleDownload()) {
            return true;
        }

        if (file.isSingleDownload()) {
            if(file.getDownloadCount() > 0) {
                throw new NoDownloadPermissionException("File has already been downloaded.");
            }
            if(!file.isPasswordProtected()) {
                return true;
            }
        }

        if(file.getDownloadPassword().equals(password)) {
            return true;
        }

        throw new NoDownloadPermissionException("Password protected file can only be downloaded with correct password.");

    }
}
